package WebFlow.QS;

import WebFlow.event.*;
import WebFlow.*;

import java.util.*;
import org.omg.CORBA.*;

public class EditorImp extends WebFlow.BeanContextChildSupport
    implements EditorOperations, WebFlowModule 
{
String msg_;
org.omg.CORBA.Object peer;
PropertyChangeSupport pcs;
String vi,emacs,Editor;
WFFileDescriptor inFile,outFile;

public EditorImp(org.omg.CORBA.Object peer, String msg)
   throws WebFlow.NullPointerException
  {
    super(peer);	
    msg_ = msg;
    pcs = new PropertyChangeSupport(peer,this);
    this.peer = peer;
    //notepad = "notepad";
    //emacs = "C:\\users\\haupt\\emacs\\emacs-20.3.1\\bin\\emacs.exe";
    emacs = "/usr/npac/bin/emacs";
    vi = "vi"; 
    Editor = emacs;
    outFile = new WFFileDescriptorImpl(peer);
  }

    public void run() {

     String filename = inFile.getFileDirectory()+inFile.getFileName();
     System.out.println("inFile: "+filename);
     String command = Editor+" "+filename;   
     if(Editor.equals("vi")) {
       command = "xterm -d aga.npac.syr.edu:0 -e vi "+filename;
     }   
     try { 
      Process p = Runtime.getRuntime().exec(command);
      p.waitFor();
     }
     catch (Exception e) {System.out.println("Editor Error: "+e.toString());}
     pcs.fireEvent("Event101",outFile);
    }  

    public void Method1() {
    System.out.println("method1 of editor requires WFFiledescriptor");
    }
	// input port 1
        // it expects WFFileDescriptor of inFile
    
    public void Method1(WFFileDescriptor fd) {
       inFile = WFFileDescriptorHelper.narrow(fd);
       run();
    }

    public void Method2() {
    }    

    public void Method3() {
    }    

    public void setEditor(String x) {
      if(x.equals("emacs")) Editor=emacs;
      else  Editor=vi;
    }
}



